VERSION 2.00
Begin Form DynBaum 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Nicht nderbar, doppelt
   Caption         =   "Dynamischer Baum"
   ClientHeight    =   4710
   ClientLeft      =   225
   ClientTop       =   960
   ClientWidth     =   7215
   Height          =   5400
   Icon            =   DYNBAUM.FRX:0000
   Left            =   165
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   7215
   Top             =   330
   Width           =   7335
   Begin Outline Outline 
      Height          =   4455
      Left            =   120
      PictureClosed   =   DYNBAUM.FRX:0302
      PictureLeaf     =   DYNBAUM.FRX:03E4
      PictureMinus    =   DYNBAUM.FRX:04C6
      PictureOpen     =   DYNBAUM.FRX:05A8
      PicturePlus     =   DYNBAUM.FRX:068A
      TabIndex        =   0
      Top             =   120
      Width           =   6975
   End
   Begin ListBox Liste 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "Courier New"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   3180
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   6975
   End
   Begin ListBox ModulListe 
      Height          =   225
      Left            =   3000
      TabIndex        =   1
      Top             =   720
      Visible         =   0   'False
      Width           =   1200
   End
   Begin Menu menu_datei 
      Caption         =   "&Datei"
      Begin Menu menu_open 
         Caption         =   "VB-&Projekt ffnen..."
      End
      Begin Menu menu_opentrace 
         Caption         =   "Trace-&Datei ffnen..."
      End
      Begin Menu menu_d 
         Caption         =   "-"
      End
      Begin Menu menu_ende 
         Caption         =   "&Ende"
      End
   End
   Begin Menu menu_fkt 
      Caption         =   "&Dyn.Ausfhrung"
      Begin Menu menu_trace 
         Caption         =   "Code instrumentieren"
      End
      Begin Menu menu_p1 
         Caption         =   "-"
      End
      Begin Menu menu_optionen 
         Caption         =   "&Optionen"
         Begin Menu menu_option_znr 
            Caption         =   "Zeilennummern protokollieren"
         End
      End
   End
   Begin Menu menu_auswertung 
      Caption         =   "&Auswertung"
      Begin Menu menu_aufrufbaum 
         Caption         =   "Dynamischer Aufrufbaum"
      End
      Begin Menu menu_a1 
         Caption         =   "-"
      End
      Begin Menu menu_verweilzeiten 
         Caption         =   "Verweilzeiten"
         Index           =   0
      End
      Begin Menu menu_verweilzeiten 
         Caption         =   "Verweilzeiten > 0 ms"
         Index           =   1
      End
      Begin Menu menu_verweilzeiten 
         Caption         =   "Verweilzeiten >= 300 ms"
         Index           =   2
      End
      Begin Menu menu_a2 
         Caption         =   "-"
      End
      Begin Menu menu_aufrufzahlen 
         Caption         =   "Gruppierung alphabetisch"
         Index           =   0
      End
      Begin Menu menu_aufrufzahlen 
         Caption         =   "Gruppierung Aufrufzahlen"
         Index           =   1
      End
      Begin Menu menu_aufrufzahlen 
         Caption         =   "Gruppierung Verweilzeiten"
         Index           =   2
      End
   End
   Begin Menu menu_hilfe 
      Caption         =   "&Hilfe"
      Begin Menu menu_about 
         Caption         =   "ber..."
      End
   End
End

Dim tracedatei$, pfad$

Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer

Sub erstelle_modul_liste ()

'Modul/Form-Liste erstellen

maus 0
   
Caption = "Dynamischer Baum  [" + get_file$(projekt$) + "]"
App.Title = Caption

ModulListe.Clear

pfad$ = get_pfad$(projekt$): If Len(pfad$) = 0 Then pfad$ = vorpfad$(CurDir$)
If Mid$(pfad$, 2, 1) <> ":" Then pfad$ = Left$(CurDir$, 2) + pfad$
pfad$ = LCase$(pfad$)

Open projekt$ For Input As #1
Do Until EOF(1)
   Line Input #1, frm$
   If InStr(frm$, "=") = 0 Then
      a$ = addpfad$(pfad$, frm$)
      If InStr(LCase$(frm$), ".bas") > 0 Or InStr(LCase$(frm$), ".frm") > 0 Then
         ModulListe.AddItem a$
      End If
   End If
Loop
Close #1

maus 1

End Sub

Sub Form_Load ()

a$ = LCase$(Command$)
projekt$ = ""
tracedatei$ = ""

If LCase$(Right$(a$, 4)) = ".tra" Then
   tracedatei$ = a$
   Caption = "Dynamischer Baum  [" + get_file$(tracedatei$) + "]"
   App.Title = Caption
ElseIf Len(a$) Then
   projekt$ = a$
   erstelle_modul_liste
End If
   
menu_fkt.Enabled = Len(projekt$) > 0
menu_auswertung.Enabled = Len(projekt$) > 0 Or Len(tracedatei$) > 0

Liste.Visible = False
Liste.Height = Outline.Height
Outline.Visible = False

End Sub

Sub menu_about_Click ()

a$ = "Erstellt fr BasicPro 2/97 von" + Chr$(10)
a$ = a$ + Chr$(10)
a$ = a$ + "Dipl.-Ing. Thomas Fssl" + Chr$(10)
a$ = a$ + "Amalienstr. 99, D-80799 Mnchen" + Chr$(10)
a$ = a$ + "EMail: 100327.2574@compuserve.com" + Chr$(10)
a$ = a$ + "http://www.basicworld.com/~fuessl/" + Chr$(10)
a$ = a$ + Chr$(10)
a$ = a$ + "Februar 1997"

MsgBox a$, 64, "Dynamischer Baum"

End Sub

Sub menu_aufrufbaum_Click ()

set_tracedatei
If exist%(tracedatei$) = 0 Then MsgBox "Datei '" + tracedatei$ + "' wurde nicht gefunden", 48, Caption: Exit Sub

maus 0

On Error GoTo fehler1

Liste.Visible = False
Outline.Visible = True
Outline.Clear

stufe% = 0
Open tracedatei$ For Input As #1
Do Until EOF(1)
   Line Input #1, a$
   b$ = zeichennext$(a$, " ")
   If b$ = "s" Then
      t$ = zeichennext$(a$, " ")
      stufe% = stufe% + 1
      Outline.AddItem a$
      Outline.Indent(Outline.ListCount - 1) = stufe%
   ElseIf b$ = "e" Or b$ = "x" Then
      stufe% = stufe% - 1
   End If
Loop
Close #1

maus 1
return1:
Exit Sub

fehler1:
maus 1
MsgBox Error$(Err), , "Fehler"
Close #1
Resume return1

End Sub

Sub menu_aufrufzahlen_Click (Index As Integer)

set_tracedatei
If exist%(tracedatei$) = 0 Then MsgBox "Datei '" + tracedatei$ + "' wurde nicht gefunden", 48, Caption: Exit Sub

maus 0

On Error GoTo fehler3

Outline.Visible = False
Liste.Visible = True
Liste.Clear

ReDim na$(100), start&(100), extra&(100)  '100: Annahme max. Verschachtelungstiefe

stufe% = 0: anz% = 0
Open tracedatei$ For Input As #1
Do Until EOF(1)
   Line Input #1, a$: a$ = Trim$(a$)
   b$ = zeichennext$(a$, " ")
   t$ = zeichennext$(a$, " "): ersetze t$, ",", "."
   If b$ = "s" Then
      stufe% = stufe% + 1
      na$(stufe%) = a$
      start&(stufe%) = Val(t$)
      extra&(stufe%) = 0
   ElseIf b$ = "e" Or b$ = "x" Then
      If Index = 2 Then
         time_inkl& = Val(t$) - start&(stufe%)
         time_exkl& = time_inkl& - extra&(stufe%)
         If stufe% > 1 Then extra&(stufe% - 1) = extra&(stufe% - 1) + time_inkl&
      Else
         time_exkl& = 1
      End If
      
      f% = suche%(Liste, na$(stufe%), 0)
      If f% Then
         Liste.ItemData(f% - 1) = Liste.ItemData(f% - 1) + time_exkl&
      Else
         Liste.AddItem na$(stufe%), suche%(Liste, na$(stufe%), 1) - 1
         Liste.ItemData(Liste.NewIndex) = time_exkl&
      End If
      anz% = anz% + 1
      
      stufe% = stufe% - 1
   End If
Loop
Close #1

For n% = Liste.ListCount To 1 Step -1
   a$ = Format$((Liste.ItemData(n% - 1)), "@@@@@")
   If Index < 2 Then
      c$ = Format$(Int(10000# * Liste.ItemData(n% - 1) / anz% + .5) / 100, "0.00")
      ersetze c$, ",", "."
      a$ = a$ + "*" + Chr$(9) + c$ + "%"
   End If
   a$ = a$ + Chr$(9) + Liste.List(n% - 1)
   If Index >= 1 Then
      Liste.RemoveItem n% - 1
      Liste.AddItem a$, suche%(Liste, a$, 2) - 1
   Else
      Liste.List(n% - 1) = a$
   End If
Next

maus 1
return3:
Exit Sub

fehler3:
maus 1
MsgBox Error$(Err), , "Fehler"
Close #1
Resume return3

End Sub

Sub menu_ende_Click ()

End

End Sub

Sub menu_open_Click ()

pfad$ = get_pfad$(projekt$)
a$ = Dialog_Open$(Me, "Projekt ffnen", pfad$, get_file$(projekt$), "Vb3-Projekte|*.mak|Alle Dateien (*.*)|*.*", "mak")

If Len(a$) Then
   projekt$ = LCase$(pfad$ + a$)
   erstelle_modul_liste
   menu_fkt.Enabled = True
   menu_auswertung.Enabled = True
End If

End Sub

Sub menu_opentrace_Click ()

pfad$ = get_pfad$(tracedatei$)
If pfad$ = "" Then pfad$ = get_pfad$(projekt$)
a$ = Dialog_Open$(Me, "Trace-Datei ffnen", pfad$, get_file$(tracedatei$), "Trace-Datei|*.tra", "tra")

If Len(a$) Then
   projekt$ = ""
   tracedatei$ = LCase$(pfad$ + a$)
   menu_fkt.Enabled = False
   menu_auswertung.Enabled = True
   Caption = "Dynamischer Baum  [" + get_file$(tracedatei$) + "]"
   App.Title = Caption
End If

End Sub

Sub menu_option_znr_Click ()

menu_option_znr.Checked = True - menu_option_znr.Checked

End Sub

Sub menu_trace_Click ()

maus 0

If exist_pfad%(pfad$ + "TRACE") = 0 Then MkDir pfad$ + "TRACE"

set_tracedatei

fktnr% = 0: fkton% = False: selcase% = False
For n% = 1 To ModulListe.ListCount
   ff$ = ModulListe.List(n% - 1)
   form$ = ""
   
   Open ff$ For Input As #1
   Open pfad$ + "TRACE\" + get_file$(ff$) For Output As #2
   
   Do Until EOF(1)
      Line Input #1, a$
      If is_sub_or_function%(a$) Then
         Print #2, a$
         a$ = Trim$(a$)
         b$ = zeichennext$(a$, " "): a$ = Trim$(a$)
         If b$ = "Private" Or b$ = "Public" Then b$ = zeichennext$(a$, " "): a$ = Trim$(a$)
         fkt$ = Trim$(zeichennext$(a$, "("))
         fktnr% = fktnr% + 1
         Print #2, "trace_start" + Chr$(34) + form$ + fkt$ + Chr$(34)
         s% = 0: fkton% = True: zeile% = 0: selcase% = False
      ElseIf Left$(Trim$(a$), 7) = "End Sub" Or Left$(Trim$(a$), 12) = "End Function" Then
         Print #2, "trace_end"
         Print #2, a$
         fkton% = False
      ElseIf is_begin_form%(a$) Then
         Print #2, a$
         a$ = Trim$(a$): b$ = zeichennext$(a$, " ")  'Begin
         a$ = Trim$(a$): b$ = zeichennext$(a$, " ")  'Typ
         If Left$(b$, 3) = "VB." Then b$ = Mid$(b$, 4)
         form$ = Trim$(a$) + "."  'Form1.
         fln$ = b$                'MDIForm oder Form
      Else
         b$ = "Exit Sub"
         Do While InStr(a$, b$)
            s% = s% + 1
            a$ = Left$(a$, InStr(a$, b$) - 1) + "trace_exit " + Str$(s%) + ": EXIT SUB" + Mid$(a$, InStr(a$, b$) + Len(b$))
         Loop
         b$ = "Exit Function"
         Do While InStr(a$, b$)
            s% = s% + 1
            a$ = Left$(a$, InStr(a$, b$) - 1) + "trace_exit " + Str$(s%) + ": EXIT FUNCTION" + Mid$(a$, InStr(a$, b$) + Len(b$))
         Loop
         If fkton% = True And menu_option_znr.Checked = True Then
            If selcase% = False Then
               zeile% = zeile% + 1
               b$ = "trace_linenr" + Str$(zeile%)
               Print #2, b$
            End If
            If Left$(Trim$(a$), 12) = "Select Case " Then selcase% = True
            If Left$(Trim$(a$), 10) = "End Select" Then selcase% = False
            If Left$(Trim$(a$), 5) = "Case " Then selcase% = False
         End If
         Print #2, a$
      End If
   Loop
   Close #2
   Close #1
Next

'erstelle mak-file, ggf. copy frx-file
Open projekt$ For Input As #1
Open pfad$ + "TRACE\" + get_file$(projekt$) For Output As #2
z% = 0
Do Until EOF(1)
   Line Input #1, a$
   z% = z% + 1
   If z% = 2 Then Print #2, vorpfad$(App.Path); "trace.bas"
   If InStr(LCase$(a$), ".bas") > 0 Then
      Print #2, get_file$(a$)
   ElseIf InStr(LCase$(a$), ".frm") > 0 Then
      Print #2, get_file$(a$)
      frx$ = Left$(a$, Len(a$) - 1) + "x"
      If exist%(pfad$ + frx$) Then FileCopy pfad$ + frx$, pfad$ + "TRACE\" + get_file$(frx$)
   Else
      Print #2, a$
   End If
Loop
Close #2
Close #1

maus 1

End Sub

Sub menu_verweilzeiten_Click (Index As Integer)

set_tracedatei
If exist%(tracedatei$) = 0 Then MsgBox "Datei '" + tracedatei$ + "' wurde nicht gefunden", 48, Caption: Exit Sub

maus 0

On Error GoTo fehler2

Outline.Visible = False
Liste.Visible = True
Liste.Clear

ReDim na$(100), start&(100), extra&(100)  '100: Annahme max. Verschachtelungstiefe

stufe% = 0
Open tracedatei$ For Input As #1
Do Until EOF(1)
   Line Input #1, a$
   b$ = zeichennext$(a$, " ")
   t$ = zeichennext$(a$, " "): ersetze t$, ",", "."
   If b$ = "s" Then
      stufe% = stufe% + 1
      na$(stufe%) = a$
      start&(stufe%) = Val(t$)
      extra&(stufe%) = 0
   ElseIf b$ = "e" Or b$ = "x" Then
      time_inkl& = Val(t$) - start&(stufe%)
      time_exkl& = time_inkl& - extra&(stufe%)
      If Index = 0 Or (Index = 1 And time_exkl& > 0) Or (Index = 2 And time_exkl& >= 300&) Then
         Liste.AddItem Trim$(Str$(time_exkl&)) + Chr$(9) + na$(stufe%)
      End If
      stufe% = stufe% - 1
      If stufe% > 0 Then extra&(stufe%) = extra&(stufe%) + time_inkl&
   End If
Loop
Close #1

maus 1
return2:
Exit Sub

fehler2:
maus 1
MsgBox Error$(Err), , "Fehler"
Close #1
Resume return2

End Sub

Sub Outline_Click ()

Outline.Expand(Outline.ListIndex) = Not Outline.Expand(Outline.ListIndex)

End Sub

Sub set_tracedatei ()

If projekt$ = "" Then Exit Sub
tracedatei$ = LCase$(pfad$ + "TRACE\" + zeichennext$(get_file$(projekt$), ".") + ".tra")

End Sub

